/**
 * output package name
 */
package com.kingdee.eas.custom.htjd.client;

import org.apache.log4j.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.BorderFactory;
import javax.swing.event.*;
import javax.swing.KeyStroke;

import com.kingdee.bos.ctrl.swing.*;
import com.kingdee.bos.ctrl.kdf.table.*;
import com.kingdee.bos.ctrl.kdf.data.event.*;
import com.kingdee.bos.dao.*;
import com.kingdee.bos.dao.query.*;
import com.kingdee.bos.metadata.*;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.ui.face.*;
import com.kingdee.bos.ui.util.ResourceBundleHelper;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.enums.EnumUtils;
import com.kingdee.bos.ui.face.UIRuleUtil;
import com.kingdee.bos.ctrl.swing.event.*;
import com.kingdee.bos.ctrl.kdf.table.event.*;
import com.kingdee.bos.ctrl.extendcontrols.*;
import com.kingdee.bos.ctrl.kdf.util.render.*;
import com.kingdee.bos.ui.face.IItemAction;
import com.kingdee.eas.framework.batchHandler.RequestContext;
import com.kingdee.bos.ui.util.IUIActionPostman;
import com.kingdee.bos.appframework.client.servicebinding.ActionProxyFactory;
import com.kingdee.bos.appframework.uistatemanage.ActionStateConst;
import com.kingdee.bos.appframework.validator.ValidateHelper;
import com.kingdee.bos.appframework.uip.UINavigator;


/**
 * output class name
 */
public abstract class AbstractContractEndEditUI extends com.kingdee.eas.xr.client.XRBillBaseEditUI
{
    private static final Logger logger = CoreUIObject.getLogger(AbstractContractEndEditUI.class);
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCreator;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCreateTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contLastUpdateUser;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contLastUpdateTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCU;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contNumber;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contBizDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contDescription;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contAuditor;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contStatus;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contBizStatus;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contAuditTime;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contprePerson;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpreDepartment;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpreCompany;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contmanager;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpurDepartment;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpurCompany;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conthtNumber;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conthtName;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conttitle;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contjjDegree;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contsuppiler;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer conthtId;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPaneremarks;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPanekeyPoint;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contkeyPoint;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contremarks;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtCreator;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkCreateTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtLastUpdateUser;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkLastUpdateTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtCU;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtNumber;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkBizDate;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtDescription;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtAuditor;
    protected com.kingdee.bos.ctrl.swing.KDComboBox comboStatus;
    protected com.kingdee.bos.ctrl.swing.KDComboBox comboBizStatus;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkAuditTime;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtprePerson;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtpreDepartment;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtpreCompany;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtmanager;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtpurDepartment;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtpurCompany;
    protected com.kingdee.bos.ctrl.swing.KDTextField txthtNumber;
    protected com.kingdee.bos.ctrl.swing.KDTextField txthtName;
    protected com.kingdee.bos.ctrl.swing.KDTextField txttitle;
    protected com.kingdee.bos.ctrl.swing.KDComboBox jjDegree;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtsuppiler;
    protected com.kingdee.bos.ctrl.swing.KDTextField txthtId;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txtremarks;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txtkeyPoint;
    protected com.kingdee.eas.custom.htjd.ContractEndInfo editData = null;
    /**
     * output class constructor
     */
    public AbstractContractEndEditUI() throws Exception
    {
        super();
        this.defaultObjectName = "editData";
        jbInit();
        
        initUIP();
    }

    /**
     * output jbInit method
     */
    private void jbInit() throws Exception
    {
        this.resHelper = new ResourceBundleHelper(AbstractContractEndEditUI.class.getName());
        this.setUITitle(resHelper.getString("this.title"));
        //actionSubmit
        String _tempStr = null;
        actionSubmit.setEnabled(true);
        actionSubmit.setDaemonRun(false);

        actionSubmit.putValue(ItemAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke("ctrl S"));
        _tempStr = resHelper.getString("ActionSubmit.SHORT_DESCRIPTION");
        actionSubmit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.LONG_DESCRIPTION");
        actionSubmit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionSubmit.NAME");
        actionSubmit.putValue(ItemAction.NAME, _tempStr);
        this.actionSubmit.setBindWorkFlow(true);
        this.actionSubmit.setExtendProperty("canForewarn", "true");
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.NetFunctionService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.UserMonitorService());
         this.actionSubmit.addService(new com.kingdee.eas.framework.client.service.ForewarnService());
        //actionUnAudit
        actionUnAudit.setEnabled(true);
        actionUnAudit.setDaemonRun(false);

        _tempStr = resHelper.getString("ActionUnAudit.SHORT_DESCRIPTION");
        actionUnAudit.putValue(ItemAction.SHORT_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionUnAudit.LONG_DESCRIPTION");
        actionUnAudit.putValue(ItemAction.LONG_DESCRIPTION, _tempStr);
        _tempStr = resHelper.getString("ActionUnAudit.NAME");
        actionUnAudit.putValue(ItemAction.NAME, _tempStr);
        this.actionUnAudit.setBindWorkFlow(true);
         this.actionUnAudit.addService(new com.kingdee.eas.framework.client.service.PermissionService());
        this.contCreator = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contCreateTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contLastUpdateUser = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contLastUpdateTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contCU = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contNumber = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contBizDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contDescription = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contAuditor = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contStatus = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contBizStatus = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contAuditTime = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contprePerson = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpreDepartment = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpreCompany = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contmanager = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpurDepartment = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpurCompany = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conthtNumber = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conthtName = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conttitle = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contjjDegree = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contsuppiler = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.conthtId = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.scrollPaneremarks = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.scrollPanekeyPoint = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.contkeyPoint = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contremarks = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.prmtCreator = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.pkCreateTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtLastUpdateUser = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.pkLastUpdateTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtCU = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.txtNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.pkBizDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.txtDescription = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.prmtAuditor = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.comboStatus = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.comboBizStatus = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.pkAuditTime = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtprePerson = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtpreDepartment = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtpreCompany = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtmanager = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtpurDepartment = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtpurCompany = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.txthtNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txthtName = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txttitle = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.jjDegree = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.prmtsuppiler = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.txthtId = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtremarks = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.txtkeyPoint = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.contCreator.setName("contCreator");
        this.contCreateTime.setName("contCreateTime");
        this.contLastUpdateUser.setName("contLastUpdateUser");
        this.contLastUpdateTime.setName("contLastUpdateTime");
        this.contCU.setName("contCU");
        this.contNumber.setName("contNumber");
        this.contBizDate.setName("contBizDate");
        this.contDescription.setName("contDescription");
        this.contAuditor.setName("contAuditor");
        this.contStatus.setName("contStatus");
        this.contBizStatus.setName("contBizStatus");
        this.contAuditTime.setName("contAuditTime");
        this.contprePerson.setName("contprePerson");
        this.contpreDepartment.setName("contpreDepartment");
        this.contpreCompany.setName("contpreCompany");
        this.contmanager.setName("contmanager");
        this.contpurDepartment.setName("contpurDepartment");
        this.contpurCompany.setName("contpurCompany");
        this.conthtNumber.setName("conthtNumber");
        this.conthtName.setName("conthtName");
        this.conttitle.setName("conttitle");
        this.contjjDegree.setName("contjjDegree");
        this.contsuppiler.setName("contsuppiler");
        this.conthtId.setName("conthtId");
        this.scrollPaneremarks.setName("scrollPaneremarks");
        this.scrollPanekeyPoint.setName("scrollPanekeyPoint");
        this.contkeyPoint.setName("contkeyPoint");
        this.contremarks.setName("contremarks");
        this.prmtCreator.setName("prmtCreator");
        this.pkCreateTime.setName("pkCreateTime");
        this.prmtLastUpdateUser.setName("prmtLastUpdateUser");
        this.pkLastUpdateTime.setName("pkLastUpdateTime");
        this.prmtCU.setName("prmtCU");
        this.txtNumber.setName("txtNumber");
        this.pkBizDate.setName("pkBizDate");
        this.txtDescription.setName("txtDescription");
        this.prmtAuditor.setName("prmtAuditor");
        this.comboStatus.setName("comboStatus");
        this.comboBizStatus.setName("comboBizStatus");
        this.pkAuditTime.setName("pkAuditTime");
        this.prmtprePerson.setName("prmtprePerson");
        this.prmtpreDepartment.setName("prmtpreDepartment");
        this.prmtpreCompany.setName("prmtpreCompany");
        this.prmtmanager.setName("prmtmanager");
        this.prmtpurDepartment.setName("prmtpurDepartment");
        this.prmtpurCompany.setName("prmtpurCompany");
        this.txthtNumber.setName("txthtNumber");
        this.txthtName.setName("txthtName");
        this.txttitle.setName("txttitle");
        this.jjDegree.setName("jjDegree");
        this.prmtsuppiler.setName("prmtsuppiler");
        this.txthtId.setName("txthtId");
        this.txtremarks.setName("txtremarks");
        this.txtkeyPoint.setName("txtkeyPoint");
        // CoreUI
        // contCreator		
        this.contCreator.setBoundLabelText(resHelper.getString("contCreator.boundLabelText"));		
        this.contCreator.setBoundLabelLength(100);		
        this.contCreator.setBoundLabelUnderline(true);
        // contCreateTime		
        this.contCreateTime.setBoundLabelText(resHelper.getString("contCreateTime.boundLabelText"));		
        this.contCreateTime.setBoundLabelLength(100);		
        this.contCreateTime.setBoundLabelUnderline(true);
        // contLastUpdateUser		
        this.contLastUpdateUser.setBoundLabelText(resHelper.getString("contLastUpdateUser.boundLabelText"));		
        this.contLastUpdateUser.setBoundLabelLength(100);		
        this.contLastUpdateUser.setBoundLabelUnderline(true);
        // contLastUpdateTime		
        this.contLastUpdateTime.setBoundLabelText(resHelper.getString("contLastUpdateTime.boundLabelText"));		
        this.contLastUpdateTime.setBoundLabelLength(100);		
        this.contLastUpdateTime.setBoundLabelUnderline(true);
        // contCU		
        this.contCU.setBoundLabelText(resHelper.getString("contCU.boundLabelText"));		
        this.contCU.setBoundLabelLength(100);		
        this.contCU.setBoundLabelUnderline(true);		
        this.contCU.setEnabled(false);		
        this.contCU.setVisible(false);
        // contNumber		
        this.contNumber.setBoundLabelText(resHelper.getString("contNumber.boundLabelText"));		
        this.contNumber.setBoundLabelLength(100);		
        this.contNumber.setBoundLabelUnderline(true);
        // contBizDate		
        this.contBizDate.setBoundLabelText(resHelper.getString("contBizDate.boundLabelText"));		
        this.contBizDate.setBoundLabelLength(100);		
        this.contBizDate.setBoundLabelUnderline(true);
        // contDescription		
        this.contDescription.setBoundLabelText(resHelper.getString("contDescription.boundLabelText"));		
        this.contDescription.setBoundLabelLength(100);		
        this.contDescription.setBoundLabelUnderline(true);		
        this.contDescription.setVisible(false);
        // contAuditor		
        this.contAuditor.setBoundLabelText(resHelper.getString("contAuditor.boundLabelText"));		
        this.contAuditor.setBoundLabelLength(100);		
        this.contAuditor.setBoundLabelUnderline(true);
        // contStatus		
        this.contStatus.setBoundLabelText(resHelper.getString("contStatus.boundLabelText"));		
        this.contStatus.setBoundLabelLength(100);		
        this.contStatus.setBoundLabelUnderline(true);		
        this.contStatus.setEnabled(false);
        // contBizStatus		
        this.contBizStatus.setBoundLabelText(resHelper.getString("contBizStatus.boundLabelText"));		
        this.contBizStatus.setBoundLabelLength(100);		
        this.contBizStatus.setBoundLabelUnderline(true);		
        this.contBizStatus.setEnabled(false);		
        this.contBizStatus.setVisible(false);
        // contAuditTime		
        this.contAuditTime.setBoundLabelText(resHelper.getString("contAuditTime.boundLabelText"));		
        this.contAuditTime.setBoundLabelLength(100);		
        this.contAuditTime.setBoundLabelUnderline(true);
        // contprePerson		
        this.contprePerson.setBoundLabelText(resHelper.getString("contprePerson.boundLabelText"));		
        this.contprePerson.setBoundLabelLength(100);		
        this.contprePerson.setBoundLabelUnderline(true);		
        this.contprePerson.setVisible(true);
        // contpreDepartment		
        this.contpreDepartment.setBoundLabelText(resHelper.getString("contpreDepartment.boundLabelText"));		
        this.contpreDepartment.setBoundLabelLength(100);		
        this.contpreDepartment.setBoundLabelUnderline(true);		
        this.contpreDepartment.setVisible(true);
        // contpreCompany		
        this.contpreCompany.setBoundLabelText(resHelper.getString("contpreCompany.boundLabelText"));		
        this.contpreCompany.setBoundLabelLength(100);		
        this.contpreCompany.setBoundLabelUnderline(true);		
        this.contpreCompany.setVisible(true);
        // contmanager		
        this.contmanager.setBoundLabelText(resHelper.getString("contmanager.boundLabelText"));		
        this.contmanager.setBoundLabelLength(100);		
        this.contmanager.setBoundLabelUnderline(true);		
        this.contmanager.setVisible(true);
        // contpurDepartment		
        this.contpurDepartment.setBoundLabelText(resHelper.getString("contpurDepartment.boundLabelText"));		
        this.contpurDepartment.setBoundLabelLength(100);		
        this.contpurDepartment.setBoundLabelUnderline(true);		
        this.contpurDepartment.setVisible(true);
        // contpurCompany		
        this.contpurCompany.setBoundLabelText(resHelper.getString("contpurCompany.boundLabelText"));		
        this.contpurCompany.setBoundLabelLength(100);		
        this.contpurCompany.setBoundLabelUnderline(true);		
        this.contpurCompany.setVisible(true);
        // conthtNumber		
        this.conthtNumber.setBoundLabelText(resHelper.getString("conthtNumber.boundLabelText"));		
        this.conthtNumber.setBoundLabelLength(100);		
        this.conthtNumber.setBoundLabelUnderline(true);		
        this.conthtNumber.setVisible(true);
        // conthtName		
        this.conthtName.setBoundLabelText(resHelper.getString("conthtName.boundLabelText"));		
        this.conthtName.setBoundLabelLength(100);		
        this.conthtName.setBoundLabelUnderline(true);		
        this.conthtName.setVisible(true);
        // conttitle		
        this.conttitle.setBoundLabelText(resHelper.getString("conttitle.boundLabelText"));		
        this.conttitle.setBoundLabelLength(100);		
        this.conttitle.setBoundLabelUnderline(true);		
        this.conttitle.setVisible(true);
        // contjjDegree		
        this.contjjDegree.setBoundLabelText(resHelper.getString("contjjDegree.boundLabelText"));		
        this.contjjDegree.setBoundLabelLength(100);		
        this.contjjDegree.setBoundLabelUnderline(true);		
        this.contjjDegree.setVisible(true);
        // contsuppiler		
        this.contsuppiler.setBoundLabelText(resHelper.getString("contsuppiler.boundLabelText"));		
        this.contsuppiler.setBoundLabelLength(100);		
        this.contsuppiler.setBoundLabelUnderline(true);		
        this.contsuppiler.setVisible(true);
        // conthtId		
        this.conthtId.setBoundLabelText(resHelper.getString("conthtId.boundLabelText"));		
        this.conthtId.setBoundLabelLength(100);		
        this.conthtId.setBoundLabelUnderline(true);		
        this.conthtId.setVisible(true);
        // scrollPaneremarks
        // scrollPanekeyPoint
        // contkeyPoint		
        this.contkeyPoint.setBoundLabelText(resHelper.getString("contkeyPoint.boundLabelText"));		
        this.contkeyPoint.setBoundLabelLength(12);		
        this.contkeyPoint.setVisible(true);		
        this.contkeyPoint.setBoundLabelAlignment(8);
        // contremarks		
        this.contremarks.setBoundLabelText(resHelper.getString("contremarks.boundLabelText"));		
        this.contremarks.setBoundLabelLength(14);		
        this.contremarks.setVisible(true);		
        this.contremarks.setBoundLabelAlignment(8);
        // prmtCreator		
        this.prmtCreator.setEnabled(false);		
        this.prmtCreator.setCommitFormat("$name$");		
        this.prmtCreator.setEditFormat("$name$");		
        this.prmtCreator.setDisplayFormat("$name$");
        // pkCreateTime		
        this.pkCreateTime.setTimeEnabled(true);		
        this.pkCreateTime.setEnabled(false);
        // prmtLastUpdateUser		
        this.prmtLastUpdateUser.setEnabled(false);		
        this.prmtLastUpdateUser.setDisplayFormat("$name$");		
        this.prmtLastUpdateUser.setEditFormat("$name$");		
        this.prmtLastUpdateUser.setCommitFormat("$name$");
        // pkLastUpdateTime		
        this.pkLastUpdateTime.setTimeEnabled(true);		
        this.pkLastUpdateTime.setEnabled(false);
        // prmtCU		
        this.prmtCU.setEnabled(false);
        // txtNumber
        // pkBizDate
        // txtDescription
        // prmtAuditor		
        this.prmtAuditor.setEnabled(false);		
        this.prmtAuditor.setCommitFormat("$name$");		
        this.prmtAuditor.setDisplayFormat("$name$");		
        this.prmtAuditor.setEditFormat("$name$");
        // comboStatus		
        this.comboStatus.addItems(EnumUtils.getEnumList("com.kingdee.eas.xr.app.XRBillStatusEnum").toArray());		
        this.comboStatus.setEnabled(false);
        // comboBizStatus		
        this.comboBizStatus.addItems(EnumUtils.getEnumList("com.kingdee.eas.xr.app.XRBizActionEnum").toArray());		
        this.comboBizStatus.setEnabled(false);		
        this.comboBizStatus.setVisible(false);
        // pkAuditTime		
        this.pkAuditTime.setTimeEnabled(true);		
        this.pkAuditTime.setEnabled(false);
        // prmtprePerson		
        this.prmtprePerson.setQueryInfo("com.kingdee.eas.basedata.person.app.PersonQuery");		
        this.prmtprePerson.setVisible(true);		
        this.prmtprePerson.setDisplayFormat("$name$");		
        this.prmtprePerson.setEditFormat("$number$");		
        this.prmtprePerson.setCommitFormat("$number$");		
        this.prmtprePerson.setRequired(false);		
        this.prmtprePerson.setEditable(true);
        this.prmtprePerson.addDataChangeListener(new com.kingdee.bos.ctrl.swing.event.DataChangeListener() {
            public void dataChanged(com.kingdee.bos.ctrl.swing.event.DataChangeEvent e) {
                try {
                    prmtprePerson_dataChanged(e);
                } catch (Exception exc) {
                    handUIException(exc);
                } finally {
                }
            }
        });
        // prmtpreDepartment		
        this.prmtpreDepartment.setQueryInfo("com.kingdee.eas.basedata.org.app.AdminItemQuery");		
        this.prmtpreDepartment.setVisible(true);		
        this.prmtpreDepartment.setDisplayFormat("$name$");		
        this.prmtpreDepartment.setEditFormat("$number$");		
        this.prmtpreDepartment.setCommitFormat("$number$");		
        this.prmtpreDepartment.setRequired(false);		
        this.prmtpreDepartment.setEditable(true);
        // prmtpreCompany		
        this.prmtpreCompany.setQueryInfo("com.kingdee.eas.basedata.org.app.CompanyOrgUnitQuery");		
        this.prmtpreCompany.setVisible(true);		
        this.prmtpreCompany.setDisplayFormat("$name$");		
        this.prmtpreCompany.setEditFormat("$number$");		
        this.prmtpreCompany.setCommitFormat("$number$");		
        this.prmtpreCompany.setRequired(false);		
        this.prmtpreCompany.setEditable(true);
        // prmtmanager		
        this.prmtmanager.setQueryInfo("com.kingdee.eas.basedata.person.app.PersonQuery");		
        this.prmtmanager.setVisible(true);		
        this.prmtmanager.setDisplayFormat("$name$");		
        this.prmtmanager.setEditFormat("$number$");		
        this.prmtmanager.setCommitFormat("$number$");		
        this.prmtmanager.setRequired(false);		
        this.prmtmanager.setEditable(true);
        this.prmtmanager.addDataChangeListener(new com.kingdee.bos.ctrl.swing.event.DataChangeListener() {
            public void dataChanged(com.kingdee.bos.ctrl.swing.event.DataChangeEvent e) {
                try {
                    prmtmanager_dataChanged(e);
                } catch (Exception exc) {
                    handUIException(exc);
                } finally {
                }
            }
        });
        // prmtpurDepartment		
        this.prmtpurDepartment.setQueryInfo("com.kingdee.eas.basedata.org.app.AdminItemQuery");		
        this.prmtpurDepartment.setVisible(true);		
        this.prmtpurDepartment.setDisplayFormat("$name$");		
        this.prmtpurDepartment.setEditFormat("$number$");		
        this.prmtpurDepartment.setCommitFormat("$number$");		
        this.prmtpurDepartment.setRequired(false);		
        this.prmtpurDepartment.setEditable(true);
        // prmtpurCompany		
        this.prmtpurCompany.setQueryInfo("com.kingdee.eas.basedata.org.app.CompanyOrgUnitQuery");		
        this.prmtpurCompany.setVisible(true);		
        this.prmtpurCompany.setEditable(true);		
        this.prmtpurCompany.setDisplayFormat("$name$");		
        this.prmtpurCompany.setEditFormat("$number$");		
        this.prmtpurCompany.setCommitFormat("$number$");		
        this.prmtpurCompany.setRequired(false);
        // txthtNumber		
        this.txthtNumber.setVisible(true);		
        this.txthtNumber.setHorizontalAlignment(2);		
        this.txthtNumber.setMaxLength(255);		
        this.txthtNumber.setRequired(false);
        // txthtName		
        this.txthtName.setVisible(true);		
        this.txthtName.setHorizontalAlignment(2);		
        this.txthtName.setMaxLength(255);		
        this.txthtName.setRequired(false);
        // txttitle		
        this.txttitle.setVisible(true);		
        this.txttitle.setHorizontalAlignment(2);		
        this.txttitle.setMaxLength(255);		
        this.txttitle.setRequired(false);
        // jjDegree		
        this.jjDegree.setVisible(true);		
        this.jjDegree.addItems(EnumUtils.getEnumList("com.kingdee.eas.custom.htjd.degree").toArray());		
        this.jjDegree.setRequired(false);
        // prmtsuppiler		
        this.prmtsuppiler.setQueryInfo("com.kingdee.eas.basedata.master.cssp.app.PSupplierQuery");		
        this.prmtsuppiler.setVisible(true);		
        this.prmtsuppiler.setEditable(true);		
        this.prmtsuppiler.setDisplayFormat("$name$");		
        this.prmtsuppiler.setEditFormat("$number$");		
        this.prmtsuppiler.setCommitFormat("$number$");		
        this.prmtsuppiler.setRequired(false);
        // txthtId		
        this.txthtId.setVisible(true);		
        this.txthtId.setHorizontalAlignment(2);		
        this.txthtId.setMaxLength(255);		
        this.txthtId.setRequired(false);
        // txtremarks		
        this.txtremarks.setVisible(true);		
        this.txtremarks.setRequired(false);		
        this.txtremarks.setMaxLength(2000);
        // txtkeyPoint		
        this.txtkeyPoint.setVisible(true);		
        this.txtkeyPoint.setRequired(false);		
        this.txtkeyPoint.setMaxLength(2000);
        this.setFocusTraversalPolicy(new com.kingdee.bos.ui.UIFocusTraversalPolicy(new java.awt.Component[] {jjDegree,txttitle,prmtprePerson,prmtpreDepartment,prmtpreCompany,prmtmanager,prmtpurDepartment,prmtpurCompany,txthtNumber,txthtName,txtkeyPoint,txtremarks,prmtsuppiler}));
        this.setFocusCycleRoot(true);
		//Register control's property binding
		registerBindings();
		registerUIState();


    }

	public com.kingdee.bos.ctrl.swing.KDToolBar[] getUIMultiToolBar(){
		java.util.List list = new java.util.ArrayList();
		com.kingdee.bos.ctrl.swing.KDToolBar[] bars = super.getUIMultiToolBar();
		if (bars != null) {
			list.addAll(java.util.Arrays.asList(bars));
		}
		return (com.kingdee.bos.ctrl.swing.KDToolBar[])list.toArray(new com.kingdee.bos.ctrl.swing.KDToolBar[list.size()]);
	}




    /**
     * output initUIContentLayout method
     */
    public void initUIContentLayout()
    {
        this.setBounds(new Rectangle(10, 10, 1013, 629));
        this.setLayout(new KDLayout());
        this.putClientProperty("OriginalBounds", new Rectangle(10, 10, 1013, 629));
        contCreator.setBounds(new Rectangle(37, 461, 270, 19));
        this.add(contCreator, new KDLayout.Constraints(37, 461, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contCreateTime.setBounds(new Rectangle(37, 498, 270, 19));
        this.add(contCreateTime, new KDLayout.Constraints(37, 498, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contLastUpdateUser.setBounds(new Rectangle(360, 461, 270, 19));
        this.add(contLastUpdateUser, new KDLayout.Constraints(360, 461, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contLastUpdateTime.setBounds(new Rectangle(360, 498, 270, 19));
        this.add(contLastUpdateTime, new KDLayout.Constraints(360, 498, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contCU.setBounds(new Rectangle(944, 426, 270, 19));
        this.add(contCU, new KDLayout.Constraints(944, 426, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contNumber.setBounds(new Rectangle(684, 11, 270, 19));
        this.add(contNumber, new KDLayout.Constraints(684, 11, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contBizDate.setBounds(new Rectangle(684, 42, 270, 19));
        this.add(contBizDate, new KDLayout.Constraints(684, 42, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contDescription.setBounds(new Rectangle(958, 360, 270, 19));
        this.add(contDescription, new KDLayout.Constraints(958, 360, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contAuditor.setBounds(new Rectangle(684, 461, 270, 19));
        this.add(contAuditor, new KDLayout.Constraints(684, 461, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contStatus.setBounds(new Rectangle(360, 132, 270, 19));
        this.add(contStatus, new KDLayout.Constraints(360, 132, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contBizStatus.setBounds(new Rectangle(950, 393, 270, 19));
        this.add(contBizStatus, new KDLayout.Constraints(950, 393, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contAuditTime.setBounds(new Rectangle(684, 498, 270, 19));
        this.add(contAuditTime, new KDLayout.Constraints(684, 498, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contprePerson.setBounds(new Rectangle(37, 71, 270, 19));
        this.add(contprePerson, new KDLayout.Constraints(37, 71, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contpreDepartment.setBounds(new Rectangle(360, 69, 270, 19));
        this.add(contpreDepartment, new KDLayout.Constraints(360, 69, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contpreCompany.setBounds(new Rectangle(684, 69, 270, 19));
        this.add(contpreCompany, new KDLayout.Constraints(684, 69, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        contmanager.setBounds(new Rectangle(37, 100, 270, 19));
        this.add(contmanager, new KDLayout.Constraints(37, 100, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contpurDepartment.setBounds(new Rectangle(360, 100, 270, 19));
        this.add(contpurDepartment, new KDLayout.Constraints(360, 100, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contpurCompany.setBounds(new Rectangle(684, 100, 270, 19));
        this.add(contpurCompany, new KDLayout.Constraints(684, 100, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        conthtNumber.setBounds(new Rectangle(37, 11, 270, 19));
        this.add(conthtNumber, new KDLayout.Constraints(37, 11, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        conthtName.setBounds(new Rectangle(37, 40, 270, 19));
        this.add(conthtName, new KDLayout.Constraints(37, 40, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        conttitle.setBounds(new Rectangle(360, 11, 270, 17));
        this.add(conttitle, new KDLayout.Constraints(360, 11, 270, 17, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contjjDegree.setBounds(new Rectangle(360, 39, 270, 19));
        this.add(contjjDegree, new KDLayout.Constraints(360, 39, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contsuppiler.setBounds(new Rectangle(37, 132, 270, 19));
        this.add(contsuppiler, new KDLayout.Constraints(37, 132, 270, 19, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        conthtId.setBounds(new Rectangle(684, 132, 270, 19));
        this.add(conthtId, new KDLayout.Constraints(684, 132, 270, 19, KDLayout.Constraints.ANCHOR_LEFT_SCALE | KDLayout.Constraints.ANCHOR_RIGHT));
        scrollPaneremarks.setBounds(new Rectangle(38, 320, 917, 72));
        this.add(scrollPaneremarks, new KDLayout.Constraints(38, 320, 917, 72, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        scrollPanekeyPoint.setBounds(new Rectangle(35, 188, 917, 102));
        this.add(scrollPanekeyPoint, new KDLayout.Constraints(35, 188, 917, 102, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT_SCALE));
        contkeyPoint.setBounds(new Rectangle(36, 167, 920, 130));
        this.add(contkeyPoint, new KDLayout.Constraints(36, 167, 920, 130, KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT));
        contremarks.setBounds(new Rectangle(35, 303, 915, 88));
        this.add(contremarks, new KDLayout.Constraints(35, 303, 915, 88, KDLayout.Constraints.ANCHOR_TOP | KDLayout.Constraints.ANCHOR_LEFT | KDLayout.Constraints.ANCHOR_RIGHT));
        //contCreator
        contCreator.setBoundEditor(prmtCreator);
        //contCreateTime
        contCreateTime.setBoundEditor(pkCreateTime);
        //contLastUpdateUser
        contLastUpdateUser.setBoundEditor(prmtLastUpdateUser);
        //contLastUpdateTime
        contLastUpdateTime.setBoundEditor(pkLastUpdateTime);
        //contCU
        contCU.setBoundEditor(prmtCU);
        //contNumber
        contNumber.setBoundEditor(txtNumber);
        //contBizDate
        contBizDate.setBoundEditor(pkBizDate);
        //contDescription
        contDescription.setBoundEditor(txtDescription);
        //contAuditor
        contAuditor.setBoundEditor(prmtAuditor);
        //contStatus
        contStatus.setBoundEditor(comboStatus);
        //contBizStatus
        contBizStatus.setBoundEditor(comboBizStatus);
        //contAuditTime
        contAuditTime.setBoundEditor(pkAuditTime);
        //contprePerson
        contprePerson.setBoundEditor(prmtprePerson);
        //contpreDepartment
        contpreDepartment.setBoundEditor(prmtpreDepartment);
        //contpreCompany
        contpreCompany.setBoundEditor(prmtpreCompany);
        //contmanager
        contmanager.setBoundEditor(prmtmanager);
        //contpurDepartment
        contpurDepartment.setBoundEditor(prmtpurDepartment);
        //contpurCompany
        contpurCompany.setBoundEditor(prmtpurCompany);
        //conthtNumber
        conthtNumber.setBoundEditor(txthtNumber);
        //conthtName
        conthtName.setBoundEditor(txthtName);
        //conttitle
        conttitle.setBoundEditor(txttitle);
        //contjjDegree
        contjjDegree.setBoundEditor(jjDegree);
        //contsuppiler
        contsuppiler.setBoundEditor(prmtsuppiler);
        //conthtId
        conthtId.setBoundEditor(txthtId);
        //scrollPaneremarks
        scrollPaneremarks.getViewport().add(txtremarks, null);
        //scrollPanekeyPoint
        scrollPanekeyPoint.getViewport().add(txtkeyPoint, null);

    }


    /**
     * output initUIMenuBarLayout method
     */
    public void initUIMenuBarLayout()
    {
        this.menuBar.add(menuFile);
        this.menuBar.add(menuEdit);
        this.menuBar.add(MenuService);
        this.menuBar.add(menuView);
        this.menuBar.add(menuBiz);
        this.menuBar.add(menuTable1);
        this.menuBar.add(menuTool);
        this.menuBar.add(menuWorkflow);
        this.menuBar.add(menuHelp);
        //menuFile
        menuFile.add(menuItemAddNew);
        menuFile.add(kDSeparator1);
        menuFile.add(menuItemCloudFeed);
        menuFile.add(menuItemSave);
        menuFile.add(menuItemCloudScreen);
        menuFile.add(menuItemSubmit);
        menuFile.add(menuItemCloudShare);
        menuFile.add(menuSubmitOption);
        menuFile.add(kdSeparatorFWFile1);
        menuFile.add(rMenuItemSubmit);
        menuFile.add(rMenuItemSubmitAndAddNew);
        menuFile.add(rMenuItemSubmitAndPrint);
        menuFile.add(separatorFile1);
        menuFile.add(MenuItemAttachment);
        menuFile.add(kDSeparator2);
        menuFile.add(menuItemPageSetup);
        menuFile.add(menuItemPrint);
        menuFile.add(menuItemPrintPreview);
        menuFile.add(kDSeparator6);
        menuFile.add(menuItemSendMail);
        menuFile.add(kDSeparator3);
        menuFile.add(menuItemExitCurrent);
        //menuSubmitOption
        menuSubmitOption.add(chkMenuItemSubmitAndAddNew);
        menuSubmitOption.add(chkMenuItemSubmitAndPrint);
        //menuEdit
        menuEdit.add(menuItemCopy);
        menuEdit.add(menuItemEdit);
        menuEdit.add(menuItemRemove);
        menuEdit.add(kDSeparator4);
        menuEdit.add(menuItemReset);
        menuEdit.add(separator1);
        menuEdit.add(menuItemCreateFrom);
        menuEdit.add(menuItemCreateTo);
        menuEdit.add(menuItemCopyFrom);
        menuEdit.add(separatorEdit1);
        menuEdit.add(menuItemEnterToNextRow);
        menuEdit.add(separator2);
        //MenuService
        MenuService.add(MenuItemKnowStore);
        MenuService.add(MenuItemAnwser);
        MenuService.add(SepratorService);
        MenuService.add(MenuItemRemoteAssist);
        //menuView
        menuView.add(menuItemFirst);
        menuView.add(menuItemPre);
        menuView.add(menuItemNext);
        menuView.add(menuItemLast);
        menuView.add(separator3);
        menuView.add(menuItemTraceUp);
        menuView.add(menuItemTraceDown);
        menuView.add(kDSeparator7);
        menuView.add(menuItemLocate);
        //menuBiz
        menuBiz.add(menuItemCancelCancel);
        menuBiz.add(menuItemCancel);
        menuBiz.add(MenuItemVoucher);
        menuBiz.add(menuItemDelVoucher);
        //menuTable1
        menuTable1.add(menuItemAddLine);
        menuTable1.add(menuItemCopyLine);
        menuTable1.add(menuItemInsertLine);
        menuTable1.add(menuItemRemoveLine);
        //menuTool
        menuTool.add(menuItemSendMessage);
        menuTool.add(menuItemMsgFormat);
        menuTool.add(menuItemCalculator);
        menuTool.add(menuItemToolBarCustom);
        //menuWorkflow
        menuWorkflow.add(menuItemStartWorkFlow);
        menuWorkflow.add(separatorWF1);
        menuWorkflow.add(menuItemViewSubmitProccess);
        menuWorkflow.add(menuItemViewDoProccess);
        menuWorkflow.add(MenuItemWFG);
        menuWorkflow.add(menuItemWorkFlowList);
        menuWorkflow.add(separatorWF2);
        menuWorkflow.add(menuItemMultiapprove);
        menuWorkflow.add(menuItemNextPerson);
        menuWorkflow.add(menuItemAuditResult);
        menuWorkflow.add(kDSeparator5);
        menuWorkflow.add(kDMenuItemSendMessage);
        //menuHelp
        menuHelp.add(menuItemHelp);
        menuHelp.add(kDSeparator12);
        menuHelp.add(menuItemRegPro);
        menuHelp.add(menuItemPersonalSite);
        menuHelp.add(helpseparatorDiv);
        menuHelp.add(menuitemProductval);
        menuHelp.add(kDSeparatorProduct);
        menuHelp.add(menuItemAbout);

    }

    /**
     * output initUIToolBarLayout method
     */
    public void initUIToolBarLayout()
    {
        this.toolBar.add(btnAddNew);
        this.toolBar.add(btnCloud);
        this.toolBar.add(btnEdit);
        this.toolBar.add(btnXunTong);
        this.toolBar.add(btnSave);
        this.toolBar.add(kDSeparatorCloud);
        this.toolBar.add(btnReset);
        this.toolBar.add(btnSubmit);
        this.toolBar.add(btnCopy);
        this.toolBar.add(btnRemove);
        this.toolBar.add(btnCancelCancel);
        this.toolBar.add(btnCancel);
        this.toolBar.add(btnAttachment);
        this.toolBar.add(btnAudit);
        this.toolBar.add(btnUnAudit);
        this.toolBar.add(separatorFW1);
        this.toolBar.add(btnPageSetup);
        this.toolBar.add(btnPrint);
        this.toolBar.add(btnPrintPreview);
        this.toolBar.add(separatorFW2);
        this.toolBar.add(btnFirst);
        this.toolBar.add(btnPre);
        this.toolBar.add(btnNext);
        this.toolBar.add(btnLast);
        this.toolBar.add(separatorFW3);
        this.toolBar.add(btnTraceUp);
        this.toolBar.add(btnTraceDown);
        this.toolBar.add(btnWorkFlowG);
        this.toolBar.add(btnSignature);
        this.toolBar.add(btnNumberSign);
        this.toolBar.add(btnViewSignature);
        this.toolBar.add(separatorFW4);
        this.toolBar.add(separatorFW7);
        this.toolBar.add(btnCreateFrom);
        this.toolBar.add(btnCopyFrom);
        this.toolBar.add(btnCreateTo);
        this.toolBar.add(separatorFW5);
        this.toolBar.add(separatorFW8);
        this.toolBar.add(btnAddLine);
        this.toolBar.add(btnCopyLine);
        this.toolBar.add(btnInsertLine);
        this.toolBar.add(btnRemoveLine);
        this.toolBar.add(separatorFW6);
        this.toolBar.add(separatorFW9);
        this.toolBar.add(btnVoucher);
        this.toolBar.add(btnDelVoucher);
        this.toolBar.add(btnAuditResult);
        this.toolBar.add(btnMultiapprove);
        this.toolBar.add(btnWFViewdoProccess);
        this.toolBar.add(btnWFViewSubmitProccess);
        this.toolBar.add(btnNextPerson);


    }

	//Regiester control's property binding.
	private void registerBindings(){
		dataBinder.registerBinding("creator", com.kingdee.eas.base.permission.UserInfo.class, this.prmtCreator, "data");
		dataBinder.registerBinding("createTime", java.sql.Timestamp.class, this.pkCreateTime, "value");
		dataBinder.registerBinding("lastUpdateUser", com.kingdee.eas.base.permission.UserInfo.class, this.prmtLastUpdateUser, "data");
		dataBinder.registerBinding("lastUpdateTime", java.sql.Timestamp.class, this.pkLastUpdateTime, "value");
		dataBinder.registerBinding("CU", com.kingdee.eas.basedata.org.CtrlUnitInfo.class, this.prmtCU, "data");
		dataBinder.registerBinding("number", String.class, this.txtNumber, "text");
		dataBinder.registerBinding("bizDate", java.util.Date.class, this.pkBizDate, "value");
		dataBinder.registerBinding("description", String.class, this.txtDescription, "text");
		dataBinder.registerBinding("auditor", com.kingdee.eas.base.permission.UserInfo.class, this.prmtAuditor, "data");
		dataBinder.registerBinding("status", com.kingdee.eas.xr.app.XRBillStatusEnum.class, this.comboStatus, "selectedItem");
		dataBinder.registerBinding("bizStatus", com.kingdee.eas.xr.app.XRBizActionEnum.class, this.comboBizStatus, "selectedItem");
		dataBinder.registerBinding("auditTime", java.sql.Timestamp.class, this.pkAuditTime, "value");
		dataBinder.registerBinding("prePerson", com.kingdee.eas.basedata.person.PersonInfo.class, this.prmtprePerson, "data");
		dataBinder.registerBinding("preDepartment", com.kingdee.eas.basedata.org.AdminOrgUnitInfo.class, this.prmtpreDepartment, "data");
		dataBinder.registerBinding("preCompany", com.kingdee.eas.basedata.org.CompanyOrgUnitInfo.class, this.prmtpreCompany, "data");
		dataBinder.registerBinding("manager", com.kingdee.eas.basedata.person.PersonInfo.class, this.prmtmanager, "data");
		dataBinder.registerBinding("purDepartment", com.kingdee.eas.basedata.org.AdminOrgUnitInfo.class, this.prmtpurDepartment, "data");
		dataBinder.registerBinding("purCompany", com.kingdee.eas.basedata.org.CompanyOrgUnitInfo.class, this.prmtpurCompany, "data");
		dataBinder.registerBinding("htNumber", String.class, this.txthtNumber, "text");
		dataBinder.registerBinding("htName", String.class, this.txthtName, "text");
		dataBinder.registerBinding("title", String.class, this.txttitle, "text");
		dataBinder.registerBinding("jjDegree", com.kingdee.eas.custom.htjd.degree.class, this.jjDegree, "selectedItem");
		dataBinder.registerBinding("suppiler", com.kingdee.eas.basedata.master.cssp.SupplierInfo.class, this.prmtsuppiler, "data");
		dataBinder.registerBinding("htId", String.class, this.txthtId, "text");
		dataBinder.registerBinding("remarks", String.class, this.txtremarks, "text");
		dataBinder.registerBinding("keyPoint", String.class, this.txtkeyPoint, "text");		
	}
	//Regiester UI State
	private void registerUIState(){		
	}
	public String getUIHandlerClassName() {
	    return "com.kingdee.eas.custom.htjd.app.ContractEndEditUIHandler";
	}
	public IUIActionPostman prepareInit() {
		IUIActionPostman clientHanlder = super.prepareInit();
		if (clientHanlder != null) {
			RequestContext request = new RequestContext();
    		request.setClassName(getUIHandlerClassName());
			clientHanlder.setRequestContext(request);
		}
		return clientHanlder;
    }
	
	public boolean isPrepareInit() {
    	return false;
    }
    protected void initUIP() {
        super.initUIP();
    }


    /**
     * output onShow method
     */
    public void onShow() throws Exception
    {
        super.onShow();
        this.jjDegree.requestFocusInWindow();
    }

	
	

    /**
     * output setDataObject method
     */
    public void setDataObject(IObjectValue dataObject)
    {
        IObjectValue ov = dataObject;        	    	
        super.setDataObject(ov);
        this.editData = (com.kingdee.eas.custom.htjd.ContractEndInfo)ov;
    }
    protected void removeByPK(IObjectPK pk) throws Exception {
    	IObjectValue editData = this.editData;
    	super.removeByPK(pk);
    	recycleNumberByOrg(editData,"NONE",editData.getString("number"));
    }
    
    protected void recycleNumberByOrg(IObjectValue editData,String orgType,String number) {
        if (!StringUtils.isEmpty(number))
        {
            try {
            	String companyID = null;            
            	com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID =com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}				
				if (!StringUtils.isEmpty(companyID) && iCodingRuleManager.isExist(editData, companyID) && iCodingRuleManager.isUseIntermitNumber(editData, companyID)) {
					iCodingRuleManager.recycleNumber(editData,companyID,number);					
				}
            }
            catch (Exception e)
            {
                handUIException(e);
            }
        }
    }
    protected void setAutoNumberByOrg(String orgType) {
    	if (editData == null) return;
		if (editData.getNumber() == null) {
            try {
            	String companyID = null;
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID = com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}
				com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
		        if (iCodingRuleManager.isExist(editData, companyID)) {
		            if (iCodingRuleManager.isAddView(editData, companyID)) {
		            	editData.setNumber(iCodingRuleManager.getNumber(editData,companyID));
		            }
	                txtNumber.setEnabled(false);
		        }
            }
            catch (Exception e) {
                handUIException(e);
                this.oldData = editData;
                com.kingdee.eas.util.SysUtil.abort();
            } 
        } 
        else {
            if (editData.getNumber().trim().length() > 0) {
                txtNumber.setText(editData.getNumber());
            }
        }
    }

    /**
     * output loadFields method
     */
    public void loadFields()
    {
        		setAutoNumberByOrg("NONE");
        dataBinder.loadFields();
    }
		protected void setOrgF7(KDBizPromptBox f7,com.kingdee.eas.basedata.org.OrgType orgType) throws Exception
		{
			com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer oufip = new com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer(orgType);
			oufip.getModel().setIsCUFilter(true);
			f7.setFilterInfoProducer(oufip);
		}

    /**
     * output storeFields method
     */
    public void storeFields()
    {
		dataBinder.storeFields();
    }

	/**
	 * ????????งต??
	 */
	protected void registerValidator() {
    	getValidateHelper().setCustomValidator( getValidator() );
		getValidateHelper().registerBindProperty("creator", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("createTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("lastUpdateUser", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("lastUpdateTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("CU", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("number", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("bizDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("description", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("auditor", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("status", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("bizStatus", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("auditTime", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("prePerson", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("preDepartment", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("preCompany", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("manager", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("purDepartment", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("purCompany", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("htNumber", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("htName", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("title", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("jjDegree", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("suppiler", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("htId", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("remarks", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("keyPoint", ValidateHelper.ON_SAVE);    		
	}



    /**
     * output setOprtState method
     */
    public void setOprtState(String oprtType)
    {
        super.setOprtState(oprtType);
        if (STATUS_ADDNEW.equals(this.oprtState)) {
        } else if (STATUS_EDIT.equals(this.oprtState)) {
        } else if (STATUS_VIEW.equals(this.oprtState)) {
        } else if (STATUS_FINDVIEW.equals(this.oprtState)) {
        }
    }

    /**
     * output prmtprePerson_dataChanged method
     */
    protected void prmtprePerson_dataChanged(com.kingdee.bos.ctrl.swing.event.DataChangeEvent e) throws Exception
    {
    }

    /**
     * output prmtmanager_dataChanged method
     */
    protected void prmtmanager_dataChanged(com.kingdee.bos.ctrl.swing.event.DataChangeEvent e) throws Exception
    {
    }

    /**
     * output getSelectors method
     */
    public SelectorItemCollection getSelectors()
    {
        SelectorItemCollection sic = new SelectorItemCollection();
		String selectorAll = System.getProperty("selector.all");
		if(StringUtils.isEmpty(selectorAll)){
			selectorAll = "true";
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("creator.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("creator.id"));
        	sic.add(new SelectorItemInfo("creator.number"));
        	sic.add(new SelectorItemInfo("creator.name"));
		}
        sic.add(new SelectorItemInfo("createTime"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("lastUpdateUser.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("lastUpdateUser.id"));
        	sic.add(new SelectorItemInfo("lastUpdateUser.number"));
        	sic.add(new SelectorItemInfo("lastUpdateUser.name"));
		}
        sic.add(new SelectorItemInfo("lastUpdateTime"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("CU.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("CU.id"));
        	sic.add(new SelectorItemInfo("CU.number"));
        	sic.add(new SelectorItemInfo("CU.name"));
		}
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("bizDate"));
        sic.add(new SelectorItemInfo("description"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("auditor.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("auditor.id"));
        	sic.add(new SelectorItemInfo("auditor.number"));
        	sic.add(new SelectorItemInfo("auditor.name"));
		}
        sic.add(new SelectorItemInfo("status"));
        sic.add(new SelectorItemInfo("bizStatus"));
        sic.add(new SelectorItemInfo("auditTime"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("prePerson.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("prePerson.id"));
        	sic.add(new SelectorItemInfo("prePerson.number"));
        	sic.add(new SelectorItemInfo("prePerson.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("preDepartment.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("preDepartment.id"));
        	sic.add(new SelectorItemInfo("preDepartment.number"));
        	sic.add(new SelectorItemInfo("preDepartment.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("preCompany.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("preCompany.id"));
        	sic.add(new SelectorItemInfo("preCompany.number"));
        	sic.add(new SelectorItemInfo("preCompany.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("manager.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("manager.id"));
        	sic.add(new SelectorItemInfo("manager.number"));
        	sic.add(new SelectorItemInfo("manager.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("purDepartment.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("purDepartment.id"));
        	sic.add(new SelectorItemInfo("purDepartment.number"));
        	sic.add(new SelectorItemInfo("purDepartment.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("purCompany.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("purCompany.id"));
        	sic.add(new SelectorItemInfo("purCompany.number"));
        	sic.add(new SelectorItemInfo("purCompany.name"));
		}
        sic.add(new SelectorItemInfo("htNumber"));
        sic.add(new SelectorItemInfo("htName"));
        sic.add(new SelectorItemInfo("title"));
        sic.add(new SelectorItemInfo("jjDegree"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("suppiler.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("suppiler.id"));
        	sic.add(new SelectorItemInfo("suppiler.number"));
        	sic.add(new SelectorItemInfo("suppiler.name"));
		}
        sic.add(new SelectorItemInfo("htId"));
        sic.add(new SelectorItemInfo("remarks"));
        sic.add(new SelectorItemInfo("keyPoint"));
        return sic;
    }        
    	

    /**
     * output actionSubmit_actionPerformed method
     */
    public void actionSubmit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionSubmit_actionPerformed(e);
    }
    	

    /**
     * output actionUnAudit_actionPerformed method
     */
    public void actionUnAudit_actionPerformed(ActionEvent e) throws Exception
    {
        super.actionUnAudit_actionPerformed(e);
    }
	public RequestContext prepareActionSubmit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionSubmit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionSubmit() {
    	return false;
    }
	public RequestContext prepareActionUnAudit(IItemAction itemAction) throws Exception {
			RequestContext request = super.prepareActionUnAudit(itemAction);		
		if (request != null) {
    		request.setClassName(getUIHandlerClassName());
		}
		return request;
    }
	
	public boolean isPrepareActionUnAudit() {
    	return false;
    }

    /**
     * output getMetaDataPK method
     */
    public IMetaDataPK getMetaDataPK()
    {
        return new MetaDataPK("com.kingdee.eas.custom.htjd.client", "ContractEndEditUI");
    }
    /**
     * output isBindWorkFlow method
     */
    public boolean isBindWorkFlow()
    {
        return true;
    }

    /**
     * output getEditUIName method
     */
    protected String getEditUIName()
    {
        return com.kingdee.eas.custom.htjd.client.ContractEndEditUI.class.getName();
    }

    /**
     * output getBizInterface method
     */
    protected com.kingdee.eas.framework.ICoreBase getBizInterface() throws Exception
    {
        return com.kingdee.eas.custom.htjd.ContractEndFactory.getRemoteInstance();
    }

    /**
     * output createNewData method
     */
    protected IObjectValue createNewData()
    {
        com.kingdee.eas.custom.htjd.ContractEndInfo objectValue = new com.kingdee.eas.custom.htjd.ContractEndInfo();
        objectValue.setCreator((com.kingdee.eas.base.permission.UserInfo)(com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentUser()));		
        return objectValue;
    }


    	protected String getTDFileName() {
    	return "/bim/custom/htjd/ContractEnd";
	}
    protected IMetaDataPK getTDQueryPK() {
    	return new MetaDataPK("com.kingdee.eas.custom.htjd.app.ContractEndQuery");
	}
    

    /**
     * output getDetailTable method
     */
    protected KDTable getDetailTable() {        
        return null;
	}
    /**
     * output applyDefaultValue method
     */
    protected void applyDefaultValue(IObjectValue vo) {        
		vo.put("jjDegree","1");
        
    }        
	protected void setFieldsNull(com.kingdee.bos.dao.AbstractObjectValue arg0) {
		super.setFieldsNull(arg0);
		arg0.put("number",null);
	}

}